%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% FI:PA171 - Digital Filters
%
% topic: Edge detection
% author: David Svoboda 
%         Masaryk University (c) 2019
% note: designed for Matlab
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% read the input image
I = imread('deti.jpg');

% ------------------------------------------------------------------------
% (Task A) compass (template based) Sobel 
% ------------------------------------------------------------------------
S1 = [1 0 -1; 2 0 -2; 1 0 -1]
S2 = [-1 0 1; -2 0 2; -1 0 1]
S3 = [2 1 0; 1 0 -1; 0 -1 -2]
S4 = [-2 -1 0; -1 0 1; 0 1 2]
S5 = [1 2 1; 0 0 0; -1 -2 -1]
S6 = [-1 -2 -1; 0 0 0; 1 2 1]
S7 = [0 1 2; -1 0 1; -2 -1 0]
S8 = [0 -1 -2; 1 0 -1; 2 1 0]

D1 = conv2(I, S1, 'same');
D2 = conv2(I, S2, 'same');
D3 = conv2(I, S3, 'same');
D4 = conv2(I, S4, 'same');
D5 = conv2(I, S5, 'same');
D6 = conv2(I, S6, 'same');
D7 = conv2(I, S7, 'same');
D8 = conv2(I, S8, 'same');

myCompassSobel = %<use the suitable operator and operands>;

% visualize
dip_image(myCompassSobel)

% ------------------------------------------------------------------------
% (Task B) Implement DoG filter
% ------------------------------------------------------------------------
% function [edges] = myDoG(input_image, sigma)
%
% input: grayscale image
% output: binary image (1-edge, 0-nonedge)


% ------------------------------------------------------------------------
% (Task C) Complete the function 'my_canny' 
% ------------------------------------------------------------------------
help my_canny
my_canny(I, 7, 2, 5)


